library filemapping;
uses Windows,SysUtils,Dialogs;
const
  C_SIZE_KILOBYTE = 4;
  C_NAME          = 'm_fractals';
  C_Ev            = 'filemappinwrite';
  C_Mut           = 'filemappinmutex';
type
  PInt      = ^Integer;
  IntArray  = array[0..$effffff] of Integer;
var
  H_FileMap, H_Event, H_Mutex: THandle;
  P_start_Address   : PInt;
  S_FileMap         : PAnsiChar;

//________________________________________________________________________________
function filemapping_read(var arr:IntArray;const arr_count:integer):integer;stdcall; export;
var
  i         : integer;
  ptmp      : PInt;
Begin
  if P_start_Address = Nil then result := 0
        else
            begin
                    WaitForSingleObject(H_Mutex, INFINITE);
                    ptmp := P_start_Address;
                    for i := 0 to arr_count do
                    begin
                        arr[i] := ptmp^;
                        inc(ptmp);
                    end;
                    ReleaseMutex(H_Mutex);
                    result := 1;
            end;
End;
//________________________________________________________________________________
function filemapping_write(var arr:IntArray;const arr_count:integer):integer;stdcall; export;
var
  i         : integer;
  ptmp      : PInt;
Begin
  if P_start_Address = Nil then result := 0
        else
            begin
                    WaitForSingleObject(H_Mutex, INFINITE);
                    ptmp := P_start_Address;
                    for i := 0 to arr_count do
                    begin
                        ptmp^ := arr[i];
                        inc(ptmp);
                    end;
                    ReleaseMutex(H_Mutex);
                    PulseEvent(H_Event);
                    result := 1;
            end;
End;
//________________________________________________________________________________
function filemapping_start:integer;
Begin
    result := 0;
    P_start_Address := Nil;
    H_FileMap := CreateFileMapping(MAXDWORD,Nil,PAGE_READWRITE,0,C_SIZE_KILOBYTE*1024,S_FileMap);
    IF (H_FileMap = 0) THEN H_FileMap := OpenFileMapping(PAGE_READWRITE,False,S_FileMap);
    IF (H_FileMap <> 0) THEN
        begin
            P_start_Address := MapViewOfFile(H_FileMap,FILE_MAP_WRITE,0,0,0);
            If (P_start_Address = Nil) Then ShowMessage('    : '+SysErrorMessage(GetLastError))
                Else result :=1;
        end
        ELSE ShowMessage('   : '+SysErrorMessage(GetLastError));

    H_Event:= CreateEvent(nil, True, False, C_Ev);
    IF H_Event = 0 THEN ShowMessage('   : '+SysErrorMessage(GetLastError));
    H_Mutex:= CreateMutex(nil, False, C_Mut);
    IF H_Mutex = 0 THEN ShowMessage('   : '+SysErrorMessage(GetLastError));
End;
//________________________________________________________________________________
function filemapping_destroy:integer;stdcall; export;
Begin
    UnMapViewOfFile(P_start_Address);
    CloseHandle(H_FileMap);
    CloseHandle(H_Event);
    CloseHandle(H_Mutex);
    P_start_Address := Nil;
    H_FileMap := 0;
    result := 1;
End;
//________________________________________________________________________________
function filemapping_create:integer;overload;stdcall; export;
Begin
     if( (P_start_Address =Nil) or (H_FileMap = 0) )then result:=filemapping_start
      else result := 1;
End;
//________________________________________________________________________________
function filemapping_create(S_filename : string):integer;overload;stdcall; export;
Begin
     S_FileMap := PAnsiChar('Global\'+S_filename);
     if( (P_start_Address =Nil) or (H_FileMap = 0) )then
        begin
              result:=filemapping_start;
        end
      else
        begin
              filemapping_destroy;
              result:=filemapping_start;
        end;
End;
//________________________________________________________________________________
exports
  filemapping_read,filemapping_write,filemapping_create,filemapping_destroy;

//-----------
BEGIN
  P_start_Address := Nil;
  H_FileMap := 0;
  S_FileMap := 'Global\'+C_NAME;
  filemapping_create;
end.
